##############################################################
# F.Gek
# RsrLiveTime
# 
# Sistema di rilevazione tempi automatici Radiators Spirng Racing
# http://www.radiators-champ.com/
#############################################################


try:
    import ac
    import acsys
    import sys
    import os
    import string
    import array
    import subprocess
    import threading
    import acFul
    from threading import Thread
except ImportError as exc55:
    ac.log("RsrLiveTimeLog - failed to import module ({})".format(exc55))

try:
    import platform
except ImportError as exc5588:
    ac.log("RsrLiveTimeLog - failed to import module platform ({})".format(exc5588))

if platform.architecture()[0] == "64bit":
  sysdir = "stdlib64"
else:
  sysdir = "stdlib"

sys.path.insert(0, os.path.join(os.path.dirname(__file__), "libreria", sysdir))
os.environ['PATH'] = os.environ['PATH'] + ";."



try:
    import configparser
except ImportError as exc2:
    ac.log("RsrLiveTimeLog - failed to import configparser module ({})".format(exc2))

try:    
    from os.path import exists
except ImportError as exc2_aa:
    ac.log("RsrLiveTimeLog - failed to import exists module ({})".format(exc2_aa))

try:
    from datetime import *
except ImportError as exc1:
    ac.log("RsrLiveTimeLog - failed to import datetime module ({})".format(exc1))


try:
    import ctypes.wintypes
except ImportError as exc1_aa:
    ac.log("RsrLiveTimeLog - failed to import ctypes.wintypes module ({})".format(exc1_aa))

#try:
#    from _socket import *
#except ImportError as exc:
#    ac.log("RsrLiveTimeLog - failed to import _socket module ({})".format(exc))

#try:
#    from socket import *
#except ImportError as exc8:
#    ac.log("RsrLiveTimeLog - failed to import socket module ({})".format(exc8))

try:
    import RsrLiveTime_a
except ImportError as exc88:
    ac.log("RsrLiveTimeLog - failed to import RsrLiveTime_a.py module ({})".format(exc88))

try:
    import time
except ImportError as exc200:
    ac.log("RsrLiveTimeLog - failed to import time module ({})".format(exc200))

try:
    from struct import *
except ImportError as exc201:
    ac.log("RsrLiveTimeLog - failed to import struct module ({})".format(exc201))
    

try:
    import py_compile
except ImportError as exc202:
    ac.log("RsrLiveTimeLog - failed to import py_compile module ({})".format(exc202))

try:
    from compileall import *
except ImportError as exc203:
    ac.log("RsrLiveTimeLog - failed to import compileall module ({})".format(exc203))

try:
    from acFul1 import *
except ImportError as exc204:
    ac.log("RsrLiveTimeLog - failed to import acFul1 module ({})".format(exc204))
    
try:
    #import configparser
    from os.path import expanduser
except ImportError as exc218:
    ac.log("RsrLiveTimeLog - failed to import expanduser module ({})".format(exc218))

try:
    from os.path import abspath
except ImportError as exc218_aa:
    ac.log("RsrLiveTimeLog - failed to import abspath module ({})".format(exc218_aa))

#try:
#    import  win32filefileHandle
#except ImportError as exc90:
#    ac.log("RsrLiveTimeLog - failed to import win32filefileHandle module ({})".format(exc90))

try:
    import pipes
except ImportError as exc95:
    ac.log("RsrLiveTimeLog - failed to import pipe module ({})".format(exc95))

#try:
#    import winsound
#except ImportError as exc96:
#    ac.log("RsrLiveTimeLog - failed to import winsound module ({})".format(exc96))


#try:
#    from acpmf import *
#except ImportError as exc220:
#    ac.log("RsrLiveTimeLog - failed to import acpmf module ({})".format(exc220))

#try:
#    import win32file
#except ImportError as exc202:
#    ac.log("RsrLiveTimeLog - failed to import win32file module ({})".format(exc202))

#try:
#    import win32pipe
#except ImportError as exc202:
#    ac.log("RsrLiveTimeLog - failed to import win32pipe module ({})".format(exc202))

    
i_y=22
space=16
FL=0

corniceTexture=0

pistonTexture=0
coronaTexture=0

stabileTexture= 0
upTexture= 0
downTexture= 0

ricercaOnTexture= 0
ricercaOffTexture= 0

globoRossoTexture= 0
globoVerdeTexture= 0


pallinaVerde=0
pallinaRossa=0

informazioneTexture=0

informazioneTexture1=0
informazioneTexture2=0
informazioneTexture3=0
informazioneTexture4=0

teamTexture=0
riga1Texture=0

Posizione=0
firstTseconds=0
nextTseconds=0

LapCountOld=-1
nGiri=0

AF_INET=2
SOCK_STREAM=1
PROTO=6

host = "127.0.0.1"
port = 55010

HOSTA = "127.0.0.1"                 # Symbolic name meaning all available interfaces
PORTA = 55015              # Arbitrary non-privileged port


hostConnesso=0

flgStatoFinestra=0
flgEspandiFinestra=0
flgInfoFinestra=0

appWindow=0
driverName ="DRIVER1"
flgStartExe=0
giroNonValido=0
FlgAcShutdown=0
flgDriverNotSet = 1

flgConnessione1=0
flgPrimoGiro=0
flgConnesso=0
timeOutRichiestaPipe=1

TempoGiroOld = 0
oldColorInfo = 0

flgOCULUS = 0

flgUpdateInCorso =0

a1 = "...CONNESSIONE AL SERVER"
a2 = "CONNECTING TO THE SERVER"
a3 = "VERBINDUNG ZUM SERVER..."
a4 = "CONEXION CON EL SERVIDOR"
a5 = "-----"
a6 = "-----"
a7 = "-----"


fileName1 = "wsLiveTime.txt"
flgFirstConnection = 0



class RsrLiveTime:

    def __init__(self,app,x,y):

         self.xPosition=x
         self.yPosition=y
          
         #self.buttonInfo=ac.addButton(app,"?")
         #RsrLiveTime_a.CreaButtonInfo(self.buttonInfo,ac)
         #ac.addOnClickedListener(self.buttonInfo, buttonInfoClick)
         
         #ac.setPosition(self.buttonInfo,356,142)  
         #ac.setSize(self.buttonInfo,12,12)
         #ac.setVisible(self.buttonInfo, 1)
         #ac.setBackgroundOpacity(self.buttonInfo, 0)
         #ac.setBackgroundColor(self.buttonInfo, 0,0,0)

         #self.buttonEspandi=ac.addButton(app,">")
         #RsrLiveTime_a.CreaButtonEspandi(self.buttonEspandi,ac)
         #ac.addOnClickedListener(self.buttonEspandi, buttonEspandiClick)
         
         y=y+i_y + 4
         self.labelFirst=ac.addLabel(app,"")
         ac.setPosition(self.labelFirst,x,y-8)
         
         self.labelFirstValue=ac.addLabel(app,"------------")
         ac.setPosition(self.labelFirstValue,x+space,y-8)
         ac.setFontSize(self.labelFirstValue,14)
         ac.setFontColor(self.labelFirstValue,0.23,1,0.6,1)
         ac.setBackgroundOpacity(self.labelFirstValue, 1)
         ac.setBackgroundColor(self.labelFirstValue, 1,0.2,0.7)
         ac.drawBorder(self.labelFirstValue,1)
 
         self.labelFirstDiffValue=ac.addLabel(app,"------------")
         ac.setPosition(self.labelFirstDiffValue,260,y-8)
         ac.setFontSize(self.labelFirstDiffValue,14)
         ac.setFontColor(self.labelFirstDiffValue,1,0,0,1)
         ac.setVisible(self.labelFirstDiffValue, 1)

         y=y+i_y
         self.labelNext=ac.addLabel(app,"")
         ac.setPosition(self.labelNext,x,y)

         self.labelNextValue=ac.addLabel(app,"------------")
         ac.setPosition(self.labelNextValue,x+space,y)
         ac.setFontSize(self.labelNextValue,14)

         self.labelNextDiffValue=ac.addLabel(app,"------------")
         ac.setPosition(self.labelNextDiffValue,260,y)
         ac.setFontSize(self.labelNextDiffValue,14)
         ac.setFontColor(self.labelNextDiffValue,1,0,0,1)
         ac.setVisible(self.labelNextDiffValue, 1)

         y=y+i_y
         self.labelAct=ac.addLabel(app,"")
         ac.setPosition(self.labelAct,x,y)
         self.labelActValue=ac.addLabel(app,"------------")
         ac.setPosition(self.labelActValue,x+space,y)
         ac.setFontSize(self.labelActValue,14)

         y=y+i_y
         self.labelPrev=ac.addLabel(app,"")
         ac.setPosition(self.labelPrev,x,y)
         self.labelPrevValue=ac.addLabel(app,"------------")
         ac.setPosition(self.labelPrevValue,x+space,y)
         ac.setFontSize(self.labelPrevValue,14)

         self.labelPrevDiffValue=ac.addLabel(app,"------------")
         ac.setPosition(self.labelPrevDiffValue,260,y)
         ac.setFontSize(self.labelPrevDiffValue,14)
         ac.setFontColor(self.labelPrevDiffValue,0.2,1,0,1)
         ac.setVisible(self.labelPrevDiffValue, 1)
         
         #self.labelSitoOmbra=ac.addLabel(app,acFul.Info.caricaRisorsa(0))
         #ac.setPosition(self.labelSitoOmbra,32+2,140+2)
         #ac.setFontSize(self.labelSitoOmbra,14)
         #ac.setFontColor(self.labelSitoOmbra,0.3,0.3,0.3,1)

         self.labelSito=ac.addLabel(app,acFul.Info.caricaRisorsa(0))
         ac.setPosition(self.labelSito,32,154)
         ac.setFontSize(self.labelSito,14)
         ac.setFontColor(self.labelSito,1.0,0.56,0,1)

         #self.labelFL1Ombra=ac.addLabel(app,acFul.Info.caricaRisorsa(2))
         #ac.setPosition(self.labelFL1Ombra,2+2,160+2)
         #ac.setFontSize(self.labelFL1Ombra,14)
         #ac.setFontColor(self.labelFL1Ombra,0,0,0,0.4)
         
         #self.labelFL1=ac.addLabel(app,acFul.Info.caricaRisorsa(2))
         #ac.setPosition(self.labelFL1,2,160)
         #ac.setFontSize(self.labelFL1,14)
         #ac.setFontColor(self.labelFL1,0.8,0.8,0.8,1)

         #self.labelFL2Ombra=ac.addLabel(app,acFul.Info.caricaRisorsa(3))
         #ac.setPosition(self.labelFL2Ombra,2+2,176+2)
         #ac.setFontSize(self.labelFL2Ombra,14)
         #ac.setFontColor(self.labelFL2Ombra,0,0,0,0.4)
         
         #self.labelFL2=ac.addLabel(app,acFul.Info.caricaRisorsa(3))
         #ac.setPosition(self.labelFL2,2,176)
         #ac.setFontSize(self.labelFL2,14)
         #ac.setFontColor(self.labelFL2,0.8,0.8,0.8,1)

         #self.labelFL3Ombra=ac.addLabel(app,acFul.Info.caricaRisorsa(4))
         #ac.setPosition(self.labelFL3Ombra,2+2,192+2)
         #ac.setFontSize(self.labelFL3Ombra,14)
         #ac.setFontColor(self.labelFL3Ombra,0,0,0,0.4)
         
         #self.labelFL3=ac.addLabel(app,acFul.Info.caricaRisorsa(4))
         #ac.setPosition(self.labelFL3,2,192)
         #ac.setFontSize(self.labelFL3,14)
         #ac.setFontColor(self.labelFL3,0.8,0.8,0.8,1)

         #self.labelFL4Ombra=ac.addLabel(app,acFul.Info.caricaRisorsa(5))
         #ac.setPosition(self.labelFL4Ombra,2+2,220+2)
         #ac.setFontSize(self.labelFL4Ombra,12)
         #ac.setFontColor(self.labelFL4Ombra,0,0,0,0.4)
         
         #self.labelFL4=ac.addLabel(app,acFul.Info.caricaRisorsa(5))
         #ac.setPosition(self.labelFL4,2,220)
         #ac.setFontSize(self.labelFL4,12)
         #ac.setFontColor(self.labelFL4,1.0,1,0.0,1)

         #ac.setVisible(self.labelFL1Ombra, 0)
         #ac.setVisible(self.labelFL1, 0)
         #ac.setVisible(self.labelFL2Ombra, 0)
         #ac.setVisible(self.labelFL2, 0)
         #ac.setVisible(self.labelFL3Ombra, 0)
         #ac.setVisible(self.labelFL3, 0)
         #ac.setVisible(self.labelFL4Ombra, 0)
         #ac.setVisible(self.labelFL4, 0)
      
       

    def setValues(self,firstT,nextT,actT,prevT,diffF,diffN,diffP):
         if firstT == 0:
            ac.setText(self.labelFirstValue,"--")
         else:
            ac.setText(self.labelFirstValue,firstT[3:])

         if nextT == 0:
            ac.setText(self.labelNextValue,"--")
         else:
            ac.setText(self.labelNextValue,nextT)

         if actT == 0:
            ac.setText(self.labelActValue,"--")
         else:
            ac.setText(self.labelActValue,actT)

         if prevT == 0:
            ac.setText(self.labelPrevValue,"--")
         else:
            ac.setText(self.labelPrevValue,prevT)

         ac.setText(self.labelFirstDiffValue,diffF)
         ac.setText(self.labelNextDiffValue,diffN)
         ac.setText(self.labelPrevDiffValue,diffP)

    def setInfoLabel(self,info):
         #ac.setText(self.labelSitoOmbra,info)
         ac.setText(self.labelSito,info)

    def setColorInfoLabel(self,color):
         global  oldColorInfo,informazioneTexture1,informazioneTexture2,informazioneTexture3,informazioneTexture4

         if oldColorInfo != color :
            oldColorInfo = color
            if color == "0":
                ac.setFontColor(self.labelSito,1.0,0.64,0,1)
            elif color =="1":
                ac.setFontColor(self.labelSito,0.43,0.83,1.00,1)
            elif color =="2":
                ac.setFontColor(self.labelSito,1.0,0.0,0.0,1)
            elif color =="3":
                ac.setFontColor(self.labelSito,0.49,1.0,0.10,1)

    def setDriverValues(self,nome):
          global flgDriverNotSet
          
          if nome == "DRIVER1":
                flgDriverNotSet=0;
          else:
                flgDriverNotSet=0;
    
    def setEditPanel(self,tipo):
            global driverName,flgDriverNotSet
          
    def setEditPanelEspandi(self,tipo):
            if tipo == 0:

                if flgInfoFinestra == 1:
                    ac.setSize(appWindow,280,240)
                else:
                    ac.setSize(appWindow,280,160)

                #ac.setPosition(self.buttonEspandi,265,40) 
                ac.setPosition(self.buttonInfo,265,1) 
                #ac.setText(self.buttonEspandi,">") 
                ac.setVisible(self.labelFirstDiffValue, 0)
                ac.setVisible(self.labelNextDiffValue, 0)
                ac.setVisible(self.labelPrevDiffValue, 0)
            else:
                if flgInfoFinestra == 1:
                    ac.setSize(appWindow,380,240)
                else:
                    ac.setSize(appWindow,380,180)
                #ac.setPosition(self.buttonEspandi,365,40) 
                ac.setPosition(self.buttonInfo,365,1)  
                #ac.setText(self.buttonEspandi,"<") 
                ac.setVisible(self.labelFirstDiffValue, 1)
                ac.setVisible(self.labelNextDiffValue, 1)
                ac.setVisible(self.labelPrevDiffValue, 1)
            
    #def setEditPanelInfo(self,tipo):
            #if tipo == 0:
            #    ac.setSize(appWindow,380,160)
            #    
            #    ac.setVisible(self.labelFL1Ombra, 0)
            #    ac.setVisible(self.labelFL1, 0)
            #    ac.setVisible(self.labelFL2Ombra, 0)
            #    ac.setVisible(self.labelFL2, 0)
            #    ac.setVisible(self.labelFL3Ombra, 0)
            #    ac.setVisible(self.labelFL3, 0)
            #    ac.setVisible(self.labelFL4Ombra, 0)
            #    ac.setVisible(self.labelFL4, 0)
            #else:
            #    
            #    ac.setSize(appWindow,380,240)
            #    ac.setVisible(self.labelFL1Ombra, 1)
            #    ac.setVisible(self.labelFL1, 1)
            #    ac.setVisible(self.labelFL2Ombra, 1)
            #    ac.setVisible(self.labelFL2, 1)
            #    ac.setVisible(self.labelFL3Ombra, 1)
            #    ac.setVisible(self.labelFL3, 1)
            #    ac.setVisible(self.labelFL4Ombra, 1)
            #    ac.setVisible(self.labelFL4, 1)
   
def acMain(ac_version):
    global label, FL ,pistonTexture,LapCountOld,appWindow,a1,a2,a3,a4,a5,a6,a7,driverName,fileName1,riga1Texture,giroNonValido,pallinaVerde,pallinaRossa,acshm,lab,coronaTexture,stabileTexture,upTexture,downTexture,ricercaOnTexture,ricercaOffTexture,corniceTexture,globoRossoTexture,globoVerdeTexture,informazioneTexture,informazioneTexture1,informazioneTexture2,informazioneTexture3,informazioneTexture4,teamTexture,flgFirstConnection
    global flgOCULUS

    try:

        appWindow=ac.newApp("RsrLiveTime")
        ac.setSize(appWindow,380,180)

        
        #lab = ac.addLabel(appWindow, "")
        #ac.setSize(lab, 200, 30)
        #ac.setPosition(lab, 30, 30)

        try:
            acshm = AcSharedMemory(AC_GRAPHICS+AC_PHYSICS+AC_STATIC)  
        except error as err_acshm1:
            ac.log("RsrLiveTimeLog - F.GEK - fase 2 ({})".format(err_acshm1))
            ac.console("RsrLiveTimeLog - F.GEK - fase 2 ({})".format(err_acshm1))
            pass
        #corniceTexture=ac.newTexture("apps/python/RsrLiveTime/Image/Cornice004.png")

        pistonTexture=ac.newTexture("apps/python/RsrLiveTime/Image/piston002.png")
        coronaTexture=ac.newTexture("apps/python/RsrLiveTime/Image/Corona.png")

        stabileTexture=ac.newTexture("apps/python/RsrLiveTime/Image/Stabile.png")
        upTexture=ac.newTexture("apps/python/RsrLiveTime/Image/Up.png")
        downTexture=ac.newTexture("apps/python/RsrLiveTime/Image/Down.png")

        ricercaOnTexture=ac.newTexture("apps/python/RsrLiveTime/Image/RicercaOn.png")
        ricercaOffTexture=ac.newTexture("apps/python/RsrLiveTime/Image/RicercaOff.png")

        globoRossoTexture=ac.newTexture("apps/python/RsrLiveTime/Image/Globo002.png")
        globoVerdeTexture=ac.newTexture("apps/python/RsrLiveTime/Image/Connesso001.png")

        informazioneTexture=ac.newTexture("apps/python/RsrLiveTime/Image/information001.png")

        informazioneTexture1=ac.newTexture("apps/python/RsrLiveTime/Image/information001.png")
        informazioneTexture2=ac.newTexture("apps/python/RsrLiveTime/Image/information002.png")
        informazioneTexture3=ac.newTexture("apps/python/RsrLiveTime/Image/information003.png")
        informazioneTexture4=ac.newTexture("apps/python/RsrLiveTime/Image/information004.png")


        teamTexture=ac.newTexture("apps/python/RsrLiveTime/Image/RSRLogo.png")


        riga1Texture=ac.newTexture("apps/python/RsrLiveTime/Image/riga001.png")
        #riga2=ac.newTexture("apps/python/RsrLiveTime/Image/riga001.png")
        #riga3=ac.newTexture("apps/python/RsrLiveTime/Image/riga001.png")
        #riga4=ac.newTexture("apps/python/RsrLiveTime/Image/riga001.png")
        #riga5=ac.newTexture("apps/python/RsrLiveTime/Image/riga001.png")
        pallinaVerde=ac.newTexture("apps/python/RsrLiveTime/Image/Glass_ball_green.png")
        pallinaRossa=ac.newTexture("apps/python/RsrLiveTime/Image/Glass_ball_red.png")

        ac.addRenderCallback(appWindow , onFormRender)
        ac.addOnAppActivatedListener(appWindow, onAppActivated)
        ac.addOnAppDismissedListener(appWindow, onAppDismissed)
        FL=RsrLiveTime(appWindow,10,20)
        
        acFul.Info.avviaExe(0)

        
        #ac.log("RsrLiveTimeLog - F.GEK inizio compila 1")
        #py_compile.compile("apps/python/RsrLiveTime/RsrLiveTime_a.py")
        #py_compile.compile("apps/python/RsrLiveTime/acFul1.py")
        #py_compile.compile("apps/python/RsrLiveTime/acFul.py")

        ac.log("RsrLiveTimeLog - F.GEK Main verifica oculus")

        try:
            CSIDL_PERSONAL= 5       # My Documents
            SHGFP_TYPE_CURRENT= 0   # Want current, not default value

            buf= ctypes.create_unicode_buffer(ctypes.wintypes.MAX_PATH)
            ctypes.windll.shell32.SHGetFolderPathW(0, CSIDL_PERSONAL, 0, SHGFP_TYPE_CURRENT, buf)

            ac.log("RsrLiveTimeLog - F.GEK " +  str(buf.value))

            tmp_1 = str(os.environ.get('HOME'))
            tmp_2 = str(os.environ.get('USERPROFILE'))
            tmp_3 = str(os.environ.get('HOMEPATH'))
            tmp_4 = str(os.environ.get('HOMEDRIVE'))
            ac.log("RsrLiveTimeLog - F.GEK " +  tmp_1)
            ac.log("RsrLiveTimeLog - F.GEK " +  tmp_2)
            ac.log("RsrLiveTimeLog - F.GEK " +  tmp_3)
            ac.log("RsrLiveTimeLog - F.GEK " +  tmp_4)

            
            config = configparser.ConfigParser()
            path1 = r'~/Documents/Assetto Corsa/cfg/video.ini'
            ac.log("RsrLiveTimeLog - F.GEK a " + path1)
            #rel_path1 = "video.ini"
            #abs_file_path1 = os.path.join(path1, rel_path1)
            abs_file_path1 = path1
            ac.log("RsrLiveTimeLog - F.GEK b " + abs_file_path1)
            ac.log("RsrLiveTimeLog - F.GEK c " + abspath(expanduser(abs_file_path1)))
            config.read(abspath(expanduser(abs_file_path1)))
            ac.log("RsrLiveTimeLog - F.GEK c ")
            section = "CAMERA"
            key = "MODE"
            ac.log("RsrLiveTimeLog - F.GEK d ")
            tipoVideo = config.get("CAMERA", "MODE")
            ac.log("RsrLiveTimeLog - F.GEK Video mode " + tipoVideo)

            #str.startswith( 'this' )
            #if tipoVideo == 'OCULUS ':
            
            if tipoVideo.startswith("OCULUS"):
                flgOCULUS = 1
                ac.log("RsrLiveTimeLog - F.GEK OCULUS VIDEO ({})".format(flgOCULUS))
            else:
                flgOCULUS = 0
                ac.log("RsrLiveTimeLog - F.GEK NO OCULUS VIDEO ({})".format(flgOCULUS))

        except Exception as exc96_9:
            flgOCULUS = 0
            ac.log("RsrLiveTimeLog - failed rsr_ac ({})".format(exc96_9))
        except:
            flgOCULUS = 0
            ac.log("RsrLiveTimeLog - errore inatteso ")

    except error as err_tf:
        ac.log("RsrLiveTimeLog - F.GEK - Errore main ({})".format(err_tf))
        pass

    ac.log("RsrLiveTimeLog - F.GEK Finito avvio")
    return "RsrLiveTime"

xx2=305

def onAppActivated(deltaT):
    global FL,pistonTexture,LapCountOld,a1,a2,a3,a4,a5,a6,a7,driverName,riga1Texture,pallinaVerde,pallinaRossa,giroNonValido
    ac.log("RsrLiveTimeLog - Attivato")

def onAppDismissed(deltaT):
    global FL,pistonTexture,LapCountOld,a1,a2,a3,a4,a5,a6,a7,driverName,riga1Texture,pallinaVerde,pallinaRossa,giroNonValido
    ac.log("RsrLiveTimeLog - Terminato")
     
def onFormRender(deltaT):
    global FL,pistonTexture,LapCountOld,a1,a2,a3,a4,a5,a6,a7,driverName,riga1Texture,pallinaVerde,pallinaRossa,giroNonValido,TempoGiroOld,coronaTexture,stabileTexture,upTexture,downTexture,ricercaOnTexture,ricercaOffTexture,corniceTexture,flgPrimoGiro,globoRossoTexture,globoVerdeTexture,flgConnesso,informazioneTexture,informazioneTexture1,informazioneTexture2,informazioneTexture3,informazioneTexture4,teamTexture,timeOutRichiestaPipe
    ac.glColor4f(1,1,1,1)
    
    if flgOCULUS == 1:
        return

    if flgConnesso == 0:
        ac.glQuadTextured(240,30,128,128,ricercaOffTexture)
    else:
        ac.glQuadTextured(0,36,24,24,pistonTexture)

    ac.glQuadTextured(4,32,xx2+50,1,riga1Texture)
    ac.glQuadTextured(4,62,xx2+50,1,riga1Texture)
    ac.glQuadTextured(4,88,xx2+50,1,riga1Texture)
    ac.glQuadTextured(4,110,xx2+50,1,riga1Texture)
    ac.glQuadTextured(4,132,xx2+50,1,riga1Texture)

    ac.glQuadTextured(90,1,156,42,teamTexture)
    
    TempoGiro = ac.getCarState(0,acsys.CS.LapTime)
    nGiri = ac.getCarState(0,acsys.CS.LapCount)

    if TempoGiro > 0 and nGiri == 0 and TempoGiroOld ==0:
        ac.log("RsrLiveTimeLog - F.GEK - Partenza primo giro !!!")
        TempoGiroOld = 99999

    if TempoGiroOld > TempoGiro:
        ac.log("RsrLiveTimeLog - F.GEK - TempoGiroOld > TempoGiro")
        if LapCountOld > 0:
            ac.log("RsrLiveTimeLog - F.GEK - LapCountOld > 0")
            LapCountOld = -1
        else:
            ac.log("RsrLiveTimeLog - F.GEK - LapCountOld < 1")
            LapCountOld = -1
    #else:
        #ac.log("RsrLiveTimeLog - F.GEK - TempoGiroOld < TempoGiro")

    TempoGiroOld = TempoGiro
    #ac.log("RsrLiveTimeLog - F.GEK - TempoGiroOld < TempoGiro")
    #ac.log("RsrLiveTimeLog - TempoGiroOld ({})".format(TempoGiroOld))
    #ac.log("RsrLiveTimeLog - TempoGiro ({})".format(TempoGiro))

    
    #Sporco1 = ac.getCarState(0,acsys.CS.TyreDirtyLevel)
    
    #acshm.readValue("gek001", "GiroNonValido")
    acshm.readSection("gek001")
    

    if  acshm.shm["gek001"].memStruct["GiroNonValido"]["val"] == "1":
        giroNonValido = 1
    else:
        giroNonValido = 0
    #ac.console( acshm.shm["gek001"].memStruct["GiroNonValido"]["val"])
    #ac.console( acshm.shm["gek001"].memStruct["StatoPosizione"]["val"])
    if  acshm.shm["gek001"].memStruct["StatoPosizione"]["val"] == "0":
        ac.glQuadTextured(0,88,24,24,stabileTexture)

    if  acshm.shm["gek001"].memStruct["StatoPosizione"]["val"] == "1":
        ac.glQuadTextured(0,88,24,24,upTexture)

    if  acshm.shm["gek001"].memStruct["StatoPosizione"]["val"] == "2":
        ac.glQuadTextured(0,88,24,24,downTexture)

    if giroNonValido == 1:
        ac.glQuadTextured(45,3,24,24,pallinaRossa)    
    else:
        ac.glQuadTextured(45,3,24,24,pallinaVerde)

    
    if nGiri != LapCountOld:
        ac.log("RsrLiveTimeLog - F.GEK update aggiorna ************************************************")
        LapCountOld=nGiri
        giroNonValido = 0
        t = threading.Timer(timeOutRichiestaPipe, myfunc)
        t.start()

    FL.setValues(a1,a2,a3,a4,a5,a6,a7)

    info =acshm.shm["gek001"].memStruct["Info"]["val"]
    if info == "" :
        info = "Radiators springs racing team"
    FL.setInfoLabel(info)

    colore =acshm.shm["gek001"].memStruct["ColoreInfo"]["val"]
    if colore == "" :
        colore = "0"
    FL.setColorInfoLabel(colore)

    ac.console("RsrLiveTimeLog - Colore ({})".format(colore))

    if colore == "0":
        ac.glQuadTextured(1,150,24,24,informazioneTexture1)
    elif colore =="1":
        ac.glQuadTextured(1,150,24,24,informazioneTexture2)
    elif colore =="2":
        ac.glQuadTextured(1,150,24,24,informazioneTexture3)
    elif colore =="3":
        ac.glQuadTextured(1,150,24,24,informazioneTexture4)

def acShutdown():
    global FlgAcShutdown
    
    ac.log("RsrLiveTimeLog - F.GEK - Chiusura in corso")
    ac.log("RsrLiveTimeLog - F.GEK - Chiusura pipe")
    #acshm.closeSection("gek001")
    ac.log("RsrLiveTimeLog - F.GEK - Pipe chiuse")
    FlgAcShutdown=1
    ac.log("RsrLiveTimeLog - F.GEK - Richiesta invio byebye")
    t = threading.Timer(0, myfuncUscita)
    t.start()
    
#def beep(sound):
#    winsound.PlaySound('%s.wav' % sound, winsound.SND_FILENAME)

def acUpdate(deltaT):
    global FL,LapCountOld,nGiri,a1,a2,a3,a4,a5,a6,a7,driverName,giroNonValido,pallinaVerde,pallinaRossa,flgDriverNotSet
    global flgOCULUS

    if flgOCULUS == 1:
        verificaGiroOculus()
        #ac.log("RsrLiveTimeLog - F.GEK - OCULUS = 1 in acUpdate richiesta onFormRender")
        #onFormRender (deltaT)
        #ac.log("RsrLiveTimeLog - F.GEK - OCULUS = 1 in acUpdate")
        #nGiri = ac.getCarState(0,acsys.CS.LapCount)
    
#def buttonInfoClick(uno,due):
#    global flgInfoFinestra,FL,appWindow
#        
#    if flgInfoFinestra == 0:
#        flgInfoFinestra=1
#    else:
#        flgInfoFinestra=0
#    FL.setEditPanelInfo(flgInfoFinestra)


def verificaGiroOculus():
    global FL,pistonTexture,LapCountOld,a1,a2,a3,a4,a5,a6,a7,driverName,riga1Texture,pallinaVerde,pallinaRossa,giroNonValido,TempoGiroOld,coronaTexture,stabileTexture,upTexture,downTexture,ricercaOnTexture,ricercaOffTexture,corniceTexture,flgPrimoGiro,globoRossoTexture,globoVerdeTexture,flgConnesso,informazioneTexture,informazioneTexture1,informazioneTexture2,informazioneTexture3,informazioneTexture4,teamTexture,timeOutRichiestaPipe
    ac.glColor4f(1,1,1,1)
    
    ac.log("RsrLiveTimeLog - F.GEK - Oculus")
    TempoGiro = ac.getCarState(0,acsys.CS.LapTime)
    nGiri = ac.getCarState(0,acsys.CS.LapCount)

    if TempoGiro > 0 and nGiri == 0 and TempoGiroOld ==0:
        ac.log("RsrLiveTimeLog - F.GEK OC - Partenza primo giro !!!")
        TempoGiroOld = 99999

    if TempoGiroOld > TempoGiro:
        ac.log("RsrLiveTimeLog - F.GEK OC - TempoGiroOld > TempoGiro")
        if LapCountOld > 0:
            ac.log("RsrLiveTimeLog - F.GEK OC - LapCountOld > 0")
            LapCountOld = -1
        else:
            ac.log("RsrLiveTimeLog - F.GEK OC - LapCountOld < 1")
            LapCountOld = -1
    
    TempoGiroOld = TempoGiro
    acshm.readSection("gek001")
    
    if  acshm.shm["gek001"].memStruct["GiroNonValido"]["val"] == "1":
        giroNonValido = 1
    else:
        giroNonValido = 0
   
    if nGiri != LapCountOld:
        ac.log("RsrLiveTimeLog - F.GEK OC update aggiorna ************************************************")
        LapCountOld=nGiri
        giroNonValido = 0
        t = threading.Timer(timeOutRichiestaPipe, myfunc)
        t.start()

def myfuncUscita():
    ac.log("RsrLiveTimeLog - F.GEK - myfuncUscita")
    RsrLiveTime_a.inviaComandoByeBYe(ac)

def myfunc():
     global FL,nGiri,a1,a2,a3,a4,a5,a6,a7,driverName,FlgAcShutdown,flgPrimoGiro,flgConnessione,s,flgConnesso,LapCountOld,timeOutRichiestaPipe,flgFirstConnection
     global flgUpdateInCorso
     try:
        ac.log("RsrLiveTimeLog - F.GEK Richiesta classifica")

        #for carId in range(ac.getCarsCount()):
            #ac.log(ac.getDriverName(carId))
            #ac.getCarLeaderboardPosition(carId)
            #ac.getCarRealTimeLeaderboardPosition(carId)
            #ac.log(ac.getCarName(carId))
            #ac.getCarState(carId, acsys.CS.Velocity)
            #ac.getCarState(carId, acsys.CS.WorldPosition)
            #ac.getCarState(carId, acsys.CS.NormalizedSplinePosition)
            #ac.getCarState(carId, acsys.CS.LapTime)
            #ac.getCarState(carId, acsys.CS.LapCount)
            #ac.getCarState(carId, acsys.CS.LastLap)
            #cur_splits=ac.getCurrentSplits(carId)
            #ac.log("RsrLiveTimeLog - idcar ({})".format(carId))
            #ac.log("RsrLiveTimeLog - split0 ({})".format(cur_splits[0]))
            #ac.log("RsrLiveTimeLog - split1 ({})".format(cur_splits[1]))

        #data = RsrLiveTime_a.RichiestaClassifica(ac,flgPrimoGiro)

        if flgUpdateInCorso ==1:
            ac.log("RsrLiveTimeLog - F.GEK - update gia attivo")
            return

        flgUpdateInCorso = 1
        data = RsrLiveTime_a.RichiestaClassifica(ac,flgFirstConnection)

        if data != -1:
            strRicevuta = '"%s"' % data
            a1 , a2 , a3 , a4 , a5 , a6 , a7 , a8  = strRicevuta.split("|")
            FL.setValues(a1,a2,a3,a4,a5,a6,a7)
            flgConnesso = 1
            ac.log("RsrLiveTimeLog - F.GEK - Completato")
            timeOutRichiestaPipe = 1     
        else:
            LapCountOld = -2
            ac.log("RsrLiveTimeLog - F.GEK - risposta mancante")  
                         
     except IOError as err_i:
        LapCountOld = -2
        flgConnesso = 0
        ac.log("RsrLiveTimeLog - F.GEK Err myfunc 1")
        pass

     except error as err_t:
        LapCountOld = -2
        flgConnesso = 0
        ac.log("RsrLiveTimeLog - F.GEK Err myfunc 2")
        pass
     
     
     if LapCountOld == -2:
         ac.log("RsrLiveTimeLog - F.GEK Richiesta classifica terminato con errori")        
         timeOutRichiestaPipe = 10
         flgUpdateInCorso = 0
     else:
         ac.log("RsrLiveTimeLog - F.GEK Richiesta classifica terminato")        
         timeOutRichiestaPipe = 1  
         flgUpdateInCorso = 0
          
     if flgFirstConnection == 0:
         flgFirstConnection = 1        
         ac.log("RsrLiveTimeLog - F.GEK First connection")
     else:
         flgFirstConnection = 1
         #ac.log("RsrLiveTimeLog - F.GEK More one connection")        
         
        
